** lambda =0.5 * gamma* t**(gamma-1)***;
** gamma =1.5;
**   Tmax=2 ***;

%let kappa=1.2;
%let gamma=1.25;
%let Tmax=2;
%let lambda=0.6;
%let nsim=1000000;
%let seed=200;


data exp;
mean = &tmax**&gamma *&lambda;
var= (&kappa * mean +1)*mean;
proc print;
title "med1: mean / variance of number of events";
run;

data med1;
 mu= &tmax**&gamma *&lambda;
do i=1 to &nsim;
 ** gamma X =beta*rangam(seed,alpha) has mean alpha*beta,
 ** variarance alpha*beta*beta;
  v= &kappa * rangam(&seed,1/&kappa);
  n = RAND('POISSON',v*mu);

*** alternative way for sample NB(mu,kappa): mean mu, 
  variance mu+kappa*mu*mu;
  p= 1/(1+&kappa * mu); 
  n1= RAND('NEGBINOMIAL',p, 1/&kappa);
  nnn=n;
  if nnn>3 then nnn=4;
 output;
end;
run;
proc freq data=med1;
table nnn;
run;

proc means data=med1 n mean std var min max;
var n n1;
run;

data med1_2 (keep= i n t);
set med1;
if n=0 then output;
else do;
do j=1 to n;
 unif =uniform(&seed *100);
 t = unif **(1/&gamma) * (&Tmax);
 output;
 end;
end;
proc sort; by i t;
run;

data med1_3;
retain order;
set med1_2;
by i;
if first.i then order=1;
else order=order+1;
run;

data t1;
set med1_3;
if order=1;
proc means n mean std var min max;
var t;
title "med1: mean / variance of first event time";
run;

data t2;
set med1_3;
if order=2;
proc means n mean std var min max;
var t;
title "med1: mean / variance of second event time";
run;

data t3;
set med1_3;
if order=3;
proc means n mean std var min max;
var t;
title "med1: mean / variance of third event time";
run;
