** lambda =0.5exp(0.5t) for t<1 ***;
** lambda =0.75*exp(0.5t) for t in (1,2];
**   Tmax=2 ***;

%let kappa=1.5;
%let nsim=10000000;
%let seed=200;
%let beta=0.5;
%let alpha=0.5;

data a;
alpha=&alpha;
beta=&beta;
a=exp(beta)-1;
a1=a*alpha/beta;
b=exp(2*beta)-exp(beta);
b1=b*alpha*1.5/beta;
sig=log(&kappa+1);
mid = -sig/2;
sig=sqrt(sig);


mean =a1+b1;
var = mean +(&kappa) *mean*mean;
call symput('u1',a1);
call symput('u2',b1);
call symput('mid',mid);
call symput('sig', sig);

proc print;
run;

data med1;
 u= &u1 +&u2;
do i=1 to &nsim;
  v= &mid +(&sig)*rannor(&seed);
  v=exp(v);
  n = RAND('POISSON',u*v);
 output;
end;
run;

proc means data=med1 n mean std var min max;
var u v  n;
run;



data med1_2 (keep= i n t);
set med1;
if n=0 then output;
else do;
do j=1 to n;
 unif =uniform(&seed *2)*(&u1+&u2);
 if unif<= &u1 then  t = log(unif*(&beta/&alpha)+1)/(&beta);
 else t= log((unif-&u1)*(&beta/&alpha/1.5)+exp(&beta))/(&beta);
 output;
 end;
end;
proc sort; by i t;
run;

data med1_3;
retain order n1;
set med1_2;
by i;
if first.i then n1=0;
if .< t<=1 then n1=n1+1;
run;

data check;
set med1_3;
by i;
if last.i;
if n1=1;
keep i;
run;

data check2;
merge check (in=a) med1_3;
by i;
if a;
if n=1;
run;



data med1_4;
merge check (in=a) med1_3;
by i;
if a;
nn=n-1;
if n=1 then do; t=.; end;
else do; if t<=1 then delete;
end;
run;

data nn;
set med1_4;
by i;
if last.i;
nnn=nn;
if nnn>3 then nnn=4;
proc freq; table nnn;
title "conditional simulation: distribution of nn given 1";
run;

proc means data=nn n mean std var min max;
var nn;
run;

data med1_5;
set med1_4;
by i;
if t>1;
run;


data med1_5;
retain order;
set med1_5;
by i;
if first.i then order=1;
else order=order+1;
run;



data t1;
set med1_5;
if order=1;
proc means n mean std var;
var t;
title "med1: mean / variance of first event time";
run;

data t2;
set med1_5;
if order=2;
proc means n mean std var;
var t;
title "med1: mean / variance of second event time";
run;

data t3;
set med1_5;
if order=3;
proc means n mean std var;
var t;
title "med1: mean / variance of third event time";
run;
